#!/bin/sh -e
# Copyright (C) @BABOLO  2001 .. 2010 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: ispmsactive.sh,v 1.10 2010/10/25 01:14:15 babolo Exp $

export ISPMS_CONF=%%CONFDIR%%/ispmsactive.conf
. ${ISPMS_CONF}

case $1 in
faststart)
    echo -n ' ispmsactive'
    ${0} DAEMON &
    echo $! > /var/run/ispmsactive.dog
    ;;
start)
    echo -n ' ispmsactive'
    if  [ -r /var/run/ispmsactive.pid ]; then
        kill `cat /var/run/ispmsactive.dog` `cat /var/run/ispmsactive.pid` > /dev/null 2>&1 || :
    fi
    ${0} DAEMON &
    echo $! > /var/run/ispmsactive.dog
    ;;
faststop|stop)
    echo -n ' ispmsactive'
    if  [ -r /var/run/ispmsactive.pid ]; then
        kill `cat /var/run/ispmsactive.dog` `cat /var/run/ispmsactive.pid` > /dev/null 2>&1 || :
    fi
    ;;
DAEMON)
    echo "`${date} '+%F %T'` configure ##################################" >> ${clog}
    t=1
    ex=1
    while [ "${ex}" != "0" ]; do
        ex=0
        for i in %%LIBEDIR%%/active/*; do
            if  [ -x ${i} ] && ! ${i} start >> ${clog} 2>&1; then
                ex=$(( ${ex} + 1 ))
                echo "`${date} '+%F %T'` ${i} failed!!!" >> ${clog}
            fi
        done
        ${sleep} ${t}
        t=$(( ${t} * 2 - ${t} / 2 ))
        if  [ "${ex}" != "0" ]; then
            echo "`${date} '+%F %T'` ${ex} configure again ############################" >> ${clog}
        fi
    done
    while ${true}; do
        %%LIBEDIR%%/ispmsactive &
        echo $! > /var/run/ispmsactive.pid
        wait
        echo "`${date} '+%F %T'` reconfigure ################################" >> ${clog}
        t=1
        ex=1
        while [ "${ex}" != "0" ]; do
            ex=0
            for i in %%LIBEDIR%%/active/*; do
                if  [ -x ${i} ] && ! ${i} >> ${clog} 2>&1; then
                    ex=$(( ${ex} + 1 ))
                    echo "`${date} '+%F %T'` ${i} failed!!!" >> ${clog}
                fi
            done
            ${sleep} ${t}
            t=$(( ${t} * 2 - ${t} / 2 ))
            if  [ "${ex}" != "0" ]; then
                echo "`${date} '+%F %T'` ${ex} reconfigure again ##########################" >> ${clog}
            fi
        done
    done
    ;;
esac
